#!/bin/sh

export PATH=/bin:/usr/bin:

# Un bon separateur de champs d'etree...

IFS=' 	
'

DIR=/etc/secur-pass
OUT=$DIR/out$$
MAILTO=root

trap "/bin/rm -f $DIR/pwck$$ $DIR/suid$$ $OUT ; \
      exit 1" 0 1 2 3

[ ! -d $DIR ] && mkdir $DIR

set - `ls -lc /etc/passwd`

if [ "$1" != "-r--r--r--" -o "$3" != "root" ]
then
    echo "Attention ! Probleme de droits sur /etc/passwd :" >> $OUT
    echo $* >> $OUT
    chmod 444 /etc/passwd
    chown root /etc/passwd
    (echo "corrige."  && echo) >> $OUT
fi

if [ -x pwck ]
then
    pwck > $DIR/pwck$$ 2>&1
    if [ ! -f $DIR/pwck.out ]
    then
        touch $DIR/pwck.out
        echo "$DIR/pwck.out cree." >> $OUT
    else
        diff $DIR/pwck.out $DIR/pwck$$ >> $OUT || \
        echo "changements dans pwck." >> $OUT
    fi
    mv -f $DIR/pwck$$ $DIR/pwck.out 
fi

# rechrche des comptes sans mot de passe
grep '^[^:]*::' /etc/passwd >> $OUT && \
(echo "AJOUTER MOT DE PASSE A CES COMPTES") >> $OUT

# recherche des comptes ayant un id 0 (=root)
grep '^[^:]*:[^:]*:0' /etc/passwd > $DIR/suid$$
if [ ! -f $DIR/suid.out ]
then
    touch $DIR/suid.out
    echo "$DIR/suid.out cree." >> $OUT
else
    diff $DIR/suid.out $DIR/suid$$ >> $OUT || \
    echo "changements dans suid." >> $OUT
fi
mv -f $DIR/suid$$ $DIR/suid.out

echo "******************************" >> $DIR/passwdck.log
date >> $DIR/passwdck.log
echo "******************************" >> $DIR/passwdck.log
 
# si il y a des choses a signaler
if [ -s $OUT ]
then
# si on est sur un terminal
    if [ -t 1 ]
    then
        cat $OUT
    else
        mail -s "[Verif de mots de passe]" $MAILTO < $OUT
    fi

    cat $OUT >> $DIR/passwdck.log
    echo >> $DIR/passwdck.log
fi

rm -f $OUT
exit 0
